//+------------------------------------------------------------------+
//|                                                    Code Test.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"


extern int slippage               = 2;
extern int trailingstop           = 0;
extern double takeprofit          = 120;  
extern double stoploss            = 30;
extern double lots                = 1;
extern double minutestime         = 300;
extern string nameEA              = "Code Test";


//Other Declaration

double realSL, realTP, ATR, ATRSTOP;
double ma1, ma2, ma3, PSAR1, PSAR2, PSAR3;
bool BUYING, SELLING, I1, I2, I3, I4, HGC, CGC, CGC1, indicatorsignalBUY, indicatorsignalSELL;
double OOP30,OOP60,OOP90,OOP120, SOOP30, SOOP60, SOOP90, SOOP120, ATRSTOPV, Ordertest;
int trailsequencer;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
     {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
 {
  IndicatorCalculation();
  if(Bars < 100)
    {
      Print ("Not enough bars for this strategy -", nameEA);
      return(-1);
      
    }
    
//++-----------------------------------------------------------------------------------------------++    
    //Assignment
int totalOrders = OrdersTotal();
int numPos, ticket, cnt;
    
ATRSTOP= Ask - (ATR*3); 
ATRSTOPV =Ask - (ATR*2);

OOP30=  OrderOpenPrice() + 30*Point;
OOP90=  OrderOpenPrice() + 90*Point;
OOP60=  OrderOpenPrice() + 60*Point;
OOP120= OrderOpenPrice() + 120*Point; 

SOOP30=  OrderOpenPrice() - 30*Point;
SOOP60=  OrderOpenPrice() - 60*Point;
SOOP90=  OrderOpenPrice() - 90*Point;
SOOP120= OrderOpenPrice() - 120*Point;
                          

//++--------------------------------------------------------------------------------------------------++
//start loop checking for closing positions    
  for(cnt =0; cnt < totalOrders; cnt++)
    {
      OrderSelect(cnt, SELECT_BY_POS);
      if(OrderSymbol() == Symbol() && OrderType() <= OP_SELL && OrderComment() == nameEA)
         {
            numPos++;
            //check for closing short positions
            if(OrderType()== OP_SELL && Bid < SOOP30)//If we have a short position and the current profit is greater than 30 pips. Pass to switch
                   {                                 //otherwise keep equity SL in place                                                
                      switch(trailsequencer)
                         {                              
                            case 1 :                      
                                if(Bid > SOOP60)//Now in case 1, if Bid is greater than 60 (remember it's implied it's already less than 30), so profit is inbetween 30&60
                                    {
                                    if (NormalizeDouble(ma3,Digits) != OrderStopLoss()) //30 pips of profit. Modify the order to move SL to the 3rd MA (55 PMA)
                                         {     
                                          OrderModify(OrderTicket(),OrderOpenPrice(),ma3, OrderTakeProfit(),0,Blue);
                                          Print("stoploss",DoubleToStr(OrderStopLoss(),Digits));
                                          Print("ma3",DoubleToStr(ma3,Digits));
                                          }
                                         }
                                        else                               
                                        {
                                        trailsequencer++;
                                        }
                                         break;                                                            
                             case 2 :             
                                 if(Bid > (SOOP90))
                                     if (NormalizeDouble(ma2,Digits) != OrderStopLoss())
                                     {
                                     OrderModify(OrderTicket(),OrderOpenPrice(),ma2, OrderTakeProfit(),0,Blue);
                                     }
                                          else
                                           {
                                           trailsequencer++;
                                           }   
                                          break;             
                            case 3 : 
                                if(Bid > (SOOP120))
                                    if (NormalizeDouble(ma1,Digits) != OrderStopLoss())
                                       {
                                       OrderModify(OrderTicket(),OrderOpenPrice(),ma1, OrderTakeProfit(),0,Blue);
                                       }
                                        break;
                          }
                      }
             else  
                     {                       
                        if(OrderType()== OP_BUY && Ask > OOP30)                                     
                              {
                                 switch(trailsequencer)                    
                                 {                              
                                    case 1 :                                                 
                                       if(Ask < OOP60)
                                           if (NormalizeDouble(ma3,Digits) != OrderStopLoss())
                                         {
                                         OrderModify(OrderTicket(),OrderOpenPrice(),ma3, OrderTakeProfit(),0,Blue);
                                         }
                                            
                                          else                               
                                             {
                                             trailsequencer++;
                                             }
                                                break;                                                            
                     
                                     case 2 :                        
                                       if(Ask < (OOP90))
                                           if (NormalizeDouble(ma2,Digits) != OrderStopLoss())
                                        {
                                        OrderModify(OrderTicket(),OrderOpenPrice(),ma2, OrderTakeProfit(),0,Blue);
                                        }
                                          else
                                             {
                                             trailsequencer++;
                                             }   
                                                 break;   
                                                                                                         
                                       case 3 : 
                                       if(Ask < (OOP120))
                                           if (NormalizeDouble(ma1,Digits) != OrderStopLoss())
                                          {
                                          OrderModify(OrderTicket(),OrderOpenPrice(),ma1, OrderTakeProfit(),0,Blue);
                                          }
                                                break;

                                }
                            }
                        }
                    }
   
  }               
         
    
                                                                                                
if(numPos < 1)
  {
    if(AccountFreeMargin() < 1000*lots)   
      {
         Print("Not enough Free Margin to trade with this lot size");
         return(0);
      }

    if(BUYING)
    
        {        
            if(stoploss > 0)
               realSL = Ask - stoploss * Point;
                                           
            if(takeprofit > 0)
               realTP = Ask + takeprofit * Point;
            //BUYING!!
            Print("BUY SL",DoubleToStr(ATR*3,Digits)); //cloudbreakers test Print("realSL =,"DoubleToStr(realSL,Digits)," realTP=",DoubleToStr(realTP,Digits));
            Print("BUY TP",DoubleToStr(realTP,Digits));
            
            ticket = OrderSend(Symbol(),OP_BUY, lots, Ask, slippage, ATRSTOP, realTP, nameEA, 887722,0,Red);
            trailsequencer = 1;
                 
            if(ticket < 0)
                  Print("OrderSend (",nameEA,") failed with error #", GetLastError());
            Alert("CODE_TEST: BUY BUY BUY");
            
         }

      if(SELLING)
         {
            if(stoploss > 0)
                 realSL = Bid + stoploss * Point;
                 ATRSTOP = Bid + (ATR*3);
            if(takeprofit > 0)
                 realTP = Bid - takeprofit * Point;
            //SELLING!!
            Print("SOOP30=",DoubleToStr(SOOP30,Digits));
            Print("SOOP60=",DoubleToStr(SOOP60,Digits));
            
            ticket = OrderSend(Symbol(),OP_SELL, lots, Bid, slippage, ATRSTOP, realTP, nameEA, 887722, 0, Red);
            trailsequencer = 1;                      
            Print("Trailsequencer",DoubleToStr(trailsequencer,Digits));
            if(ticket < 0)
                 Print ("OrderSend (",nameEA,")failed with error #", GetLastError());
            Alert("Code_TEST: SELL SELL SELL");
           }
   
   return(0);  
   }
   }
 
 

   
void IndicatorCalculation()
    {   

ma1            = iMA(NULL, 0, 8, 0, MODE_EMA, PRICE_CLOSE,0);
ma2            = iMA(NULL, 0, 21, 0, MODE_EMA, PRICE_CLOSE,0);
ma3            = iMA(NULL, 0, 55, 0, MODE_EMA, PRICE_CLOSE,0);

ATR            = iATR(NULL, 0, 21, 0); 


PSAR1          = iSAR(0, PERIOD_H1, .02, .2, 0);

BUYING = (ma1 > ma2 && ma2 > ma3);

SELLING = (ma3 > ma2 && ma2 > ma1);


   
return(0);
   }


